#include <pthread.h>
#include <rtai.h>
#include <rtai_sched.h>
#include <rtai_msg.h>
#include <rtai_mbx.h>
#include <rtai_netrpc.h>
#include <netinet/in.h>
#include <arpa/inet.h>


RT_TASK *mainTask = NULL;

main()
{
        rt_allow_nonroot_hrt();

        mainTask = rt_task_init_schmod( nam2num("MAIN"), 10, 1024, 1024, SCHED_FIFO, 1 );
        if( NULL == mainTask )
        {
                printf("Failed to create main task.\n");
                return( 0 );
        }

        struct sockaddr_in addr;
        inet_aton( "192.168.0.155", &addr.sin_addr );
        unsigned long node = addr.sin_addr.s_addr;
        printf("node = %X\n", node );
        long port = rt_request_hard_port( node );
        printf("port = %ld\n", port );
        if( port < 0 )
        {
                printf("Failed to request port\n");
        }
        else
        {
                MBX* mbx = (MBX*)RT_get_adr( node, port, "MBX4");
                if( NULL == mbx )
                {
                        printf("Failed to connect to MBX4");
                }
                else
                {
                        unsigned char buf[64];
                        memset( buf, 0, sizeof(buf) );
                        RT_mbx_receive( node, port, mbx, buf, 16 );
                        for( int i = 0 ; i < 16 ; ++i )
                        {
                                printf("%02X ", buf[ i ] );
                        }
                        printf("\n");
                }
                rt_release_port( node, port );
        }

        rt_task_delete( mainTask );
}


