#include <pthread.h>
#include <rtai.h>
#include <rtai_sched.h>
#include <rtai_msg.h>
#include <rtai_mbx.h>

RT_TASK *mainTask = NULL;
RT_TASK *task1 = NULL;
MBX *mbx;

void *thread1( void* arg )
{
	int count = 0;
	void* result = NULL;

	task1 = rt_task_init_schmod(nam2num("THRED1"), 3, 1024, 1024, SCHED_FIFO, 1 );
	if( task1 )
	{
		printf("task1 start\n");
		rt_make_hard_real_time();

		char buf[16] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
		rt_mbx_send( mbx, buf, 16 );

		rt_task_delete( task1 );
		printf("task1 end\n");
	}
	else
	{
		printf("Failed to create task1\n");
	}
	return( result );
}

main()
{
	pthread_t th1;

	rt_allow_nonroot_hrt();

	mainTask = rt_task_init_schmod(nam2num("MAIN"), 10, 1024, 1024, SCHED_FIFO, 1 );
	if( NULL == mainTask )
	{
		printf("Failed to create main task.\n");
		return( 0 );
	}
	mbx = rt_typed_named_mbx_init("MBX4", 32, FIFO_Q );
	if( NULL == mbx )
	{
		printf("Failed to initialize mbx\n");
		return( 0 );
	}

	pthread_create( &th1, NULL, thread1, NULL );
	sleep(10);

	pthread_join( th1, NULL );
	rt_task_delete( mainTask );
	rt_mbx_delete( mbx );
}

